package com.goafanti.common.dao;

import com.goafanti.admin.bo.SalesTeamBo;
import com.goafanti.common.model.SalesTeam;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 营销团队(SalesTeam)表数据库访问层
 *
 * @author makejava
 * @since 2024-12-09 10:59:45
 */
public interface SalesTeamMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    SalesTeam queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param salesTeam 查询条件
     * @return 对象列表
     */
    List<SalesTeam> findSalesTeamList(SalesTeam salesTeam);

    /**
     * 统计总行数
     *
     * @param salesTeam 查询条件
     * @return 总行数
     */
    int findSalesTeamCount(SalesTeam salesTeam);

    /**
     * 新增数据
     *
     * @param salesTeam 实例对象
     * @return 影响行数
     */
    int insert(SalesTeam salesTeam);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SalesTeam> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SalesTeam> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SalesTeam> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SalesTeam> entities);

    /**
     * 修改数据
     *
     * @param salesTeam 实例对象
     * @return 影响行数
     */
    int update(SalesTeam salesTeam);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    SalesTeam queryByName(String name);

    SalesTeamBo queryDetailsById(Integer id);

    List<SalesTeamBo> findSalesTeamLvlList(@Param("lvl") Integer lvl);

    List<SalesTeam> queryByAid(String aid);

    List<SalesTeam> queryBySuperId(Integer id);

    List<Integer> queryByAncestors(Integer id);
}

